<?php
    /*------------------------------------------------------------------------
    # cblikes.php - Stand Alone Like Component
    # ------------------------------------------------------------------------
    # author    Joomboxr Team
    # copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved.
    # license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
    # Support Forum   http://joomboxr.com/product/cbx-like/
    -------------------------------------------------------------------------*/

    // No direct access to this file
    defined('_JEXEC') or die('Restricted access');


    class CBLikeControllerCBXLikes extends JControllerAdmin
    {
        /**
         * Proxy for getModel.
         * @since	2.5
         */
        public function getModel($name = 'CBXLikes', $prefix = 'CBLikeModel', $config = array())
        {
            $model = parent::getModel($name, $prefix, array('ignore_request' => true));

            return $model;
        }

        /**
         * Removes an item.
         *
         * @return  void
         *
         * @since   12.2
         */
        public function delete()
        {
            // Check for request forgeries
            JSession::checkToken() or die(JText::_('JINVALID_TOKEN'));

            // Get items to remove from the request.
            $cid = JFactory::getApplication()->input->get('cid', array(), 'array');

            if (!is_array($cid) || count($cid) < 1)
            {
                JLog::add(JText::_($this->text_prefix . '_NO_ITEM_SELECTED'), JLog::WARNING, 'jerror');
            }
            else
            {
                // Get the model.
                $model = $this->getModel();

                // Make sure the item ids are integers
                jimport('joomla.utilities.arrayhelper');
                JArrayHelper::toInteger($cid);

                // Remove the items.
                if ($model->delete($cid))
                {
                    $this->setMessage(JText::plural($this->text_prefix . '_N_ITEMS_DELETED', count($cid)));
                }
                else
                {
                    $this->setMessage($model->getError(), 'error');
                }

                // Invoke the postDelete method to allow for the child class to access the model.
                $this->postDeleteHook($model, $cid);
            }

            $this->setRedirect(JRoute::_('index.php?option=' . $this->option . '&view=' . $this->view_list, false));
        }

    }
?>