<?php
    /*------------------------------------------------------------------------
    # cbxliketrack.php - Stand Alone Like Component
    # ------------------------------------------------------------------------
    # author    Joomboxr Team
    # copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved.
    # license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
    # Support Forum   http://joomboxr.com/product/cbx-like/
    -------------------------------------------------------------------------*/

// No direct access to this file
    defined('_JEXEC') or die('Restricted access');

    class CBLikeModelCBXLiketrack extends JModelList {

        /**
         * Constructor.
         *
         * @param   array $config An optional associative array of configuration settings.
         *
         * @since   1.6
         * @see     JController
         */
        public function __construct($config = array()) {
            if (empty($config['filter_fields'])) {
                $config['filter_fields'] = array(
                    'id', 'l.id',
                    'extensionname', 'l.extensionname',
                    'itemid', 'l.itemid',
                    'viewname', 'l.viewname',
                    'ipaddress', 'l.ipaddress',
                    'userid', 'l.userid',
                    'username', 'l.username',
                    'created', 'l.created',
                );
            }

            parent::__construct($config);
        }

        /**
         * Method to build an SQL query to load the list data.
         *
         * @return    string    An SQL query
         */
        protected function getListQuery() {
            // Create a new query object.
            $db    = JFactory::getDBO();
            $query = $db->getQuery(true);

            $query->select(
                $this->getState(
                    'list.select', 'l.id, l.extensionname, l.itemid, l.ipaddress, l.userid,l.username, l.viewname, l.created'
                )
            );



            //$query->select('*');
            $query->from('#__cbliker_liketrack l');

            // Filter by extensions
            $extension_components = $this->getState('filter.extension_components');
            $extension_views = $this->getState('filter.extension_views');

            if($extension_components != ''){
                $query->where('l.extensionname = "'.$extension_components.'"');
                if($extension_views != ''){
                    $query->where('l.viewname = "'.$extension_views.'"');
                }
            }

            $search = $this->getState('filter.search');

            if (!empty($search))
            {
                if (stripos($search, 'id:') === 0)
                {
                    $query->where('l.id = ' . (int) substr($search, 3));
                }
                else
                {
                    $search = $db->quote('%' . $db->escape($search, true) . '%');
                    $query->where('(l.viewname LIKE ' . $search . ' OR l.extensionname LIKE ' . $search .')');
                }
            }

            // Add the list ordering clause.
            $orderCol  = $this->state->get('list.ordering');
            $orderDirn = $this->state->get('list.direction');

            $query->order($db->escape($orderCol . ' ' . $orderDirn));

          //  echo "<pre>";var_dump($query);echo "</pre>";

            return $query;
        }

        protected function populateState($ordering = null, $direction = null) {

            // Load the filter state.
            $search = $this->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
            $this->setState('filter.search', $search);

            $extension_components = $this->getUserStateFromRequest($this->context . '.filter.extension_components', 'filter_extension_components', '');
            $this->setState('filter.extension_components', $extension_components);

            $extension_views = $this->getUserStateFromRequest($this->context . '.filter.extension_views', 'filter_extension_views', '');
            $this->setState('filter.extension_views', $extension_views);

            // List state information.
            parent::populateState('l.viewname', 'asc');
        }

        protected function _getList($query, $limitstart = 0, $limit = 0) {
            $ordering = $this->getState('list.ordering');
            $query->order($this->_db->quoteName($ordering) . ' ' . $this->getState('list.direction'));

            $result = parent::_getList($query, $limitstart, $limit);


            return $result;
        }

        public function getItems()
        {
            $items = parent::getItems();

            return $items;
        }
    }