<?php
    /*------------------------------------------------------------------------
    # view.html.php - Stand Alone Like Component
    # ------------------------------------------------------------------------
    # author    Joomboxr Team
    # copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved.
    # license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
    # Support Forum   http://joomboxr.com/product/cbx-like/
    -------------------------------------------------------------------------*/


    // No direct access to this file
    defined('_JEXEC') or die('Restricted access');


    class CBLikeViewCBXLikes extends JViewLegacy {

        protected $items;
        protected $pagination;
        protected $state;

        /**
         * Display the view
         *
         * @param   string $tpl The name of the template file to parse; automatically searches through the template paths.
         *
         * @return  void
         */
        function display($tpl = null) {
            // Get data from the model

            $this->items      = $this->get('Items');
            $this->pagination = $this->get('Pagination');
            $this->state      = $this->get('State');





            CBXLikesHelper::addSubmenu('cbxlikes');

            // Set the toolbar
            $this->addToolBar();

            // Show sidebar
            $this->sidebar = JHtmlSidebar::render();




            parent::display($tpl);
        }

        /**
         * Add the page title and toolbar.
         *
         * @return  void
         *
         * @since   1.6
         */
        protected function addToolBar($total = null) {

            //post format filter.
            $extension_components   = array();
            $extension_components[] = JHtml::_('select.option', 'com_virtuemart', JText::_('COM_CBLIKE_CREATED_COM_VIRTUEMART'));
            $extension_components[] = JHtml::_('select.option', 'com_content', JText::_('COM_CBLIKE_CREATED_COM_CONTENT'));
            $extension_components[] = JHtml::_('select.option', 'com_k2', JText::_('COM_CBLIKE_CREATED_COM_K2'));

            $this->extension_components = $extension_components;


            $extension_views   = array();
            $extension_views[] = JHtml::_('select.option', 'article', JText::_('COM_CBLIKE_EXTENSION_VIEW_ARTICLE'));
            $extension_views[] = JHtml::_('select.option', 'articles', JText::_('COM_CBLIKE_EXTENSION_VIEW_ARTICLES'));
            $extension_views[] = JHtml::_('select.option', 'archive', JText::_('COM_CBLIKE_EXTENSION_VIEW_ARCHIVE'));
            $extension_views[] = JHtml::_('select.option', 'categories', JText::_('COM_CBLIKE_EXTENSION_VIEW_CATEGORIES'));
            $extension_views[] = JHtml::_('select.option', 'category', JText::_('COM_CBLIKE_EXTENSION_VIEW_CATEGORY'));
            $extension_views[] = JHtml::_('select.option', 'featured', JText::_('COM_CBLIKE_EXTENSION_VIEW_FEATURED'));
            $extension_views[] = JHtml::_('select.option', 'comments', JText::_('COM_CBLIKE_EXTENSION_VIEW_COMMENTS'));
            $extension_views[] = JHtml::_('select.option', 'item', JText::_('COM_CBLIKE_EXTENSION_VIEW_ITEM'));
            $extension_views[] = JHtml::_('select.option', 'itemlist', JText::_('COM_CBLIKE_EXTENSION_VIEW_ITEMLIST'));
            $extension_views[] = JHtml::_('select.option', 'latest', JText::_('COM_CBLIKE_EXTENSION_VIEW_LATEST'));
            $extension_views[] = JHtml::_('select.option', 'askquestion', JText::_('COM_CBLIKE_EXTENSION_VIEW_ASKQUESTION'));
            $extension_views[] = JHtml::_('select.option', 'cart', JText::_('COM_CBLIKE_EXTENSION_VIEW_CART'));
            $extension_views[] = JHtml::_('select.option', 'invoice', JText::_('COM_CBLIKE_EXTENSION_VIEW_INVOICE'));
            $extension_views[] = JHtml::_('select.option', 'manufacturer', JText::_('COM_CBLIKE_EXTENSION_VIEW_MANUFACTURER'));
            $extension_views[] = JHtml::_('select.option', 'orders', JText::_('COM_CBLIKE_EXTENSION_VIEW_ORDERS'));
            $extension_views[] = JHtml::_('select.option', 'pdf', JText::_('COM_CBLIKE_EXTENSION_VIEW_PDF'));
            $extension_views[] = JHtml::_('select.option', 'productdetails', JText::_('COM_CBLIKE_EXTENSION_VIEW_PRDUCTDETAILS'));
            $extension_views[] = JHtml::_('select.option', 'recommend', JText::_('COM_CBLIKE_EXTENSION_VIEW_RECOMMEND'));
            $extension_views[] = JHtml::_('select.option', 'user', JText::_('COM_CBLIKE_EXTENSION_VIEW_USER'));
            $extension_views[] = JHtml::_('select.option', 'vendor', JText::_('COM_CBLIKE_EXTENSION_VIEW_VENDOR'));
            $extension_views[] = JHtml::_('select.option', 'virtuemart', JText::_('COM_CBLIKE_EXTENSION_VIEW_VIRTUEMART'));
            $extension_views[] = JHtml::_('select.option', 'vmplg', JText::_('COM_CBLIKE_EXTENSION_VIEW_VMPLG'));

            $this->extension_views = $extension_views;

            JToolBarHelper::title(JText::_('COM_CBLIKE_LIKE_SUMMARY_TITLE'), 'thumbs-up');


            JHtmlSidebar::addFilter(
                JText::_('COM_CBLIKE_SELECT_EXTENSION'), 'filter_extension_components', JHtml::_('select.options', $this->extension_components, 'value', 'text', $this->state->get('filter.extension_components'))
            );

            JHtmlSidebar::addFilter(
                JText::_('COM_CBLIKE_SELECT_VIEW'), 'filter_extension_views', JHtml::_('select.options', $this->extension_views, 'value', 'text', $this->state->get('filter.extension_views'))
            );

        }

        /**
         * Method to set up the document properties
         *
         * @return void
         */
        protected function setDocument() {
            $document = JFactory::getDocument();
            $document->setTitle(JText::_('CBX Likes'));
        }

        /**
         * Returns an array of fields the table can be sorted by
         *
         * @return  array  Array containing the field name to sort by as the key and display text as value
         *
         * @since   3.0
         */
        protected function getSortFields() {
            return array(
                'a.extensionname' => JText::_('COM_CBLIKE_EXTENSION_LABEL'),
                'a.viewname'      => JText::_('COM_CBLIKE_VIEW_LABEL'),
                'a.likecount'     => JText::_('COM_CBLIKE_TOTAL_LIKES_LABEL'),
                'a.guestlike'     => JText::_('COM_CBLIKE_LIKES_GUEST_LABEL'),
                'a.itemid'        => JText::_('COM_CBLIKE_ITEM_ID_LABEL'),
                'a.id'            => JText::_('JGRID_HEADING_ID'),
            );
        }

    }

?>