<?php

	/* ------------------------------------------------------------------------
	# cblikebutton.php - Content - CB Like Button
	# ------------------------------------------------------------------------
	# author    Joomboxr Team
	# copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved
	# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
	# Support Forum   http://joomboxr.com/product/cbx-like/
	-------------------------------------------------------------------------*/




// no direct access
	defined('_JEXEC') or die('Restricted access');

	jimport('joomla.plugin.plugin');
	jimport('joomla.application.component.helper');
	jimport('joomla.session.session');



	/**
	 * Content - CB Like Button
	 * @package     Joomla
	 */
	class plgContentCblikebutton extends JPlugin
	{

		/**
		 * Constructor
		 *
		 * For php4 compatability we must not use the __constructor as a constructor for plugins
		 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
		 * This causes problems with cross-referencing necessary for the observer design pattern.
		 *
		 * @access      protected
		 * @param       object $subject The object to observe
		 * @param       array $config An array that holds the plugin configuration
		 * @since       1.0
		 */
		function plgContentCblikebutton(&$subject, $config)
		{
			parent::__construct($subject, $config);
			$this->_display = true;

			JPlugin::loadLanguage('plg_content_cblikebutton', JPATH_ADMINISTRATOR);


			//cookie time and logmethod
			$this->_cookietime = intval($this->params->get('cookietime', 1));  // day
			$this->_logmethod  = intval($this->params->get('logmethod', 2));  // 2 = both, 1 = cookie  , 0 = ip


			if ($this->_cookietime == 0) $this->_cookietime = 1; //safe side

			//skip admin
			$app    = JFactory::getApplication(); //global $mainframe;  in j1.5
			$jinput = $app->input;

			if ($app->isAdmin()) {
				$this->_display = false;

				return;
			}

			if (!$this->params) {
				$this->_display = false;

				return;
			}


//        $offline = $app->getCfg('offline');
//
//        if ($this->_disabeonoffline && $offline) {
//            $this->_display = false;
//            return;
//        }


			//Basic Params
			$this->_skipitemids = $this->params->get('skipitemid', ''); //xml name is singular, fixed in version 2.5

			//var_dump($this->_skipitemids);
			$this->_itemidfiltertype = $this->params->get('itemidfiltertype', 1);     // 0 exclude  1 include   (only)

			$this->_curitemid = $jinput->getCmd('Itemid', '');
			//ar_dump($this->_curitemid);

			$this->_skipfront       = $this->params->get('skipfront', 1); //show/hide in front page
			$this->_disabeonoffline = $this->params->get('disabeonoffline', 1);
			$this->_popup           = $this->params->get('optionalpopup', 1); //remove widget while popup, default yes 1
			$this->_rss             = $this->params->get('optionalrss', 1); //remove widget from rss feed, default yes 1, for rss feed need to send format = feed
			$this->_ajax            = $this->params->get('optionalajax', 1); //remove widget from raw/ajax output, for ajax output need to send format=raw
			$this->_mview           = $this->params->get('mview', 1); // detect mobile view and enable/disable for it.
			$this->_mdevice         = false;


			$this->_buttonpos    = $this->params->get('buttonpos', 'before');     // 0 exclude  1 include   (only)
			$this->_likerestrict = intval($this->params->get('likerestrict', 0));
			$this->_guestbutton  = intval($this->params->get('guestbutton', 0));
			//$this->_loadjquery   = 1;

			/*
			$this->_skipitemids        = $this->params->get('skipitemid','');
			$this->_skipitemids      = (array) $this->_skipitemids; //show/hide for specific itemid
			$this->_itemidfiltertype   = $this->params->get('itemidfiltertype', 1);     // 0 exclude  1 include   (only)
			$this->_curitemid          = $jinput->getCmd('Itemid','');
			*/


			//for com_content component
			//$this->_incontent          = (bool)$this->params->get('enablecontent', 1);
			$this->_skipcontent = $this->params->get('skipcontent', 1); //enable for content 1 = yes 0 = no, don't be confused with variable name
			$this->_skipcat     = $this->params->get('skipcat', null); //show hide for specific categories
			$this->_skipcatview = $this->params->get('skipcatview', 0); // show/hide in category view
			//$this->_skipcatsview       = $this->params->get('skipcatsview', 0); // show/hide in categories view
			$this->_skipcontentlatestview = $this->params->get('skipcontentlatestview', 1); // show/hide in featured view

			//for com_k2 component
			//$this->_ink2         = (bool)$this->params->get('enablek2', 1);
			$this->_skipk2    = $this->params->get('skipk2', 1); //enable for k2 1 = yes 0 = no, don't be confused with variable name
			$this->_skipk2cat = $this->params->get('skipk2cat', null); //show hide for specific categories

			$this->_skipk2catview      = $this->params->get('skipk2catview', 1); // show/hide in category view, default no 0
			$this->_skipk2latestview   = $this->params->get('skipk2latestview', 1); // show/hide in latest view
			$this->_skipk2itemlistview = $this->params->get('skipk2itemlistview', 1); // show/hide in itemlist
			$this->_skipk2genericview  = $this->params->get('skipk2genericview', 1); // shows/hide in tag view
			$this->_skipk2userview     = $this->params->get('skipk2userview', 1); // show/hide in category view

			$this->_skipkgpstools = $this->params->get('skipkgpstools', 1); //enable for k2 1 = yes 0 = no, don't be confused with variable name

			$this->_skipvirtuemart = (bool)$this->params->get('skipvirtuemart', 0);
			//$this->_skiphikashop       = (bool)$this->params->get('skiphikashop', 0);


			//$this->_skipvirtuemart     = 0;
			//$this->_skiphikashop       = 0;


			//Button Features
			$this->_countbtnpos  = $this->params->get('countbtnpos', 'right');
			$this->_buttontype   = $this->params->get('buttontype', 'html');
			$this->_htmlbtncolor = $this->params->get('htmlbtncolor', '');
			$this->_buttonview   = $this->params->get('buttonview', 'normal');

			//$this->_txtbeforelike   = $this->params->get('txtbeforelike', 'Like');
			//$this->_txtafterlike    = $this->params->get('txtafterlike', 'Liked!');

			$this->_txtbeforelike = JText::_('PLG_CBLIKEBUTTON_MSG_BEFORE_LIKE');
			$this->_txtafterlike  = JText::_('PLG_CBLIKEBUTTON_MSG_AFTER_LIKE');

			$this->_imgstyle      = $this->params->get('imgstyle', 'thumb-square');
			$this->_imgbeforelike = $this->params->get('imgbeforelike', '');
			$this->_imgafterlike  = $this->params->get('imgafterlike', '');
			$this->_imgwidth      = $this->params->get('imgwidth', '');
			$this->_imgheight     = $this->params->get('imgheight', '');
			$this->_dislikebtn    = $this->params->get('showdislike', 0);


			$this->_detailcount = $this->params->get('detailcount', 0);


			$user = JFactory::getUser();


			$this->_userid = $user->id;


			// Check if component is installed
			if (!JComponentHelper::isEnabled('com_cblike', true)) {
				//echo 'This plugin requires component com_cblike!';
				JFactory::getApplication()->enqueueMessage(JText::_('PLG_CBLIKEBUTTON_COM_CBLIKE_NOTFOUND'), 'error');
				$this->_display = false;

				return;
			} else {
				require_once JPATH_SITE . '/components/com_cblike/helpers/cblikehelper.php';
				require_once JPATH_BASE . '/components/com_cblike/models/cblike.php';

				defined('CBX_LIKE_COOKIE_SET') or CbLikeHelper::init_cookie($this->_cookietime);
			}


		}
		// enf of function plgContentCblikebutton




		/**
		 * [_LikeButtonGate description]
		 * @param  [type] $context    [description]
		 * @param  [type] $article    [description]
		 * @param  [type] $params     [description]
		 * @param  [type] $limitstart [description]
		 * @return [type]             [description]
		 */
		public function _LikeButtonGate($context, &$article, &$params, $limitstart = null)
		{

			JPlugin::loadLanguage('plg_content_cblikebutton', JPATH_ADMINISTRATOR);

			if ($context == 'com_widgetkit') {
				$this->_display = false;

				return false;
			}

			// return if params are empty

			$app = JFactory::getApplication('site'); //global $mainframe;  in j1.5
			if ($app->isAdmin()) {
				$this->_display = false;

				return false;
			} //i think we already checked this condition

			$user = JFactory::getUser();



			$app         = JFactory::getApplication('site');
			$jinput      = $app->input;
			$menu        = $app->getMenu();
			$activemenu  = ($menu->getActive()) ? $menu->getActive() : $menu->getDefault();
			$defaultmenu = $menu->getDefault();


			//pick current item id
			if ($this->_curitemid == '') {
				if (isset ($activemenu->id)) {
					$this->_curitemid = $activemenu->id;
				}
			}

			$allselected = false;

			$this->_skipitemids = (array)$this->_skipitemids;



			if ($this->_skipitemids[0] == '') {
				$allselected = true;
			}

			//include or exclude for item id
			if ($allselected && $this->_itemidfiltertype) {
				//continue
			} else if ($allselected && !$this->_itemidfiltertype) {
				//all selected and exclude
				$this->_display = false;

				return false;
			} else if ($this->_curitemid != '' && $this->_itemidfiltertype && !in_array($this->_curitemid, $this->_skipitemids)) {
				//some selected and include
				$this->_display = false;

				return false;
			} else if ($this->_curitemid != '' && !$this->_itemidfiltertype && in_array($this->_curitemid, $this->_skipitemids)) {
				//some selected and exclude

				$this->_display = false;

				return false;
			}


			//disable in popup, feed or ajax request. as linkedin or some widget may not work in ajax mode where need to load external js or here need some expert excuse
			if (($this->_popup && ($jinput->getCmd('tmpl') == 'component')) || ($this->_rss && ($jinput->getCmd('format') == 'feed')) || ($this->_ajax && ($jinput->getCmd('format') == 'raw'))) {
				$this->_display = false;

				return false;
			}


			if (isset ($activemenu->id) && isset ($defaultmenu->id)) {
				$active_id  = $activemenu->id;
				$default_id = $defaultmenu->id;
				if (($active_id == $default_id) && $this->_skipfront) {
					$this->_display = false;

					return false;
				}
			}


			$doc     = JFactory::getDocument();
			$doctype = $doc->getType();
			if ($doctype !== 'html') {
				$this->_display = false;

				return false;
			}


			$mycurrentcomponent = '';
			if (isset($activemenu->component) && $activemenu->component) {
				$mycurrentcomponent = $activemenu->component;
			}

			//$contenthook = intval($contenthook);

			//plugin compatibility with other component , content is must
			//cck
			$comcontent = false;  //com_content
			//$comeventlist   = false; //com_eventlist
			//$comquickfaq    = false; //com_quickfaq
			$comk2       = false; //com_k2
			$comgpstools = false;
			/*
			$comflexi       = false; //com_flexicontent
			$comzoo         = false; // com_zoo
			*/
			//shop components
			$comvirtue   = false; //com_virtuemart
			$comhikashop = false; //com_hikashop
			/*
			$comjshopping   = false; //com_jshopping

			$commyblog      = false; //com_myblog

			$comlyftenblog  = false; //com_lyftenblog
			$comdjcatalog2  = false; //com_djcatalog2

			//from 10.1
			$commagent      = false; // com_magent
			*/


			if ($jinput->getCmd('option') == 'com_content') {
				//var_dump($context);
				//if(defined('cbsocialshareandvotebtnrndrd')){return;}

				//if($context != 'com_content.article') { return;}
				if (!($context == 'com_content.article' || $context == 'com_content.category' || $context == 'com_content.featured')) {
					$this->_display = false;

					return false;
				}
				$comcontent = true;

			} else if ($jinput->getCmd('option') == 'com_k2') {
				$contexts = array('com_k2.itemlist', 'com_k2.item');
				if (!in_array($context, $contexts)) {
					$this->_display = false;

					return false;
				}

				$comk2 = true;

			} else if ($jinput->getCmd('option') == 'com_gpstools') {
				if (!($context == 'com_content.article')) {
					$this->_display = false;

					return false;
				}
				$comgpstools = true;
			} else if ($jinput->getCmd('option') == 'com_virtuemart') {
				//var_dump('in virtuemart1');
				if ($context != 'com_virtuemart.productdetails') {
					$this->_display = false;

					return false;
				}
				$comvirtue = true;
			} else if ($jinput->getCmd('option') == 'com_hikashop') {
				//need to check here the
				//if($context != 'com_content.article') return;
				$comhikashop = true;
			} else {
				$this->_display = false;

				return false;
			}





			if ($comcontent && !$this->_skipcontent) {
				$this->_display = false;

				return false;
			}
			//if($comeventlist && !$this->_skipeventlist) {$this->_display = false; return false;}
			//if($comquickfaq && !$this->_skipquickfaq) {$this->_display = false; return false;}
			if ($comk2 && !$this->_skipk2) {
				$this->_display = false;

				return false;
			}
			if ($comgpstools && !$this->_skipkgpstools) {
				$this->_display = false;

				return false;
			}

			//if($comflexi && !$this->_skipflexic) { return;}{$this->_display = false; return false;} { return;}
			//if($comjshopping && !$this->_skipjshopping) {$this->_display = false; return false;}
			if ($comhikashop && !$this->_skiphikashop) {
				$this->_display = false;

				return false;
			}
			if ($comvirtue && !$this->_skipvirtuemart) {
				$this->_display = false;

				return false;
			}
			//if($commyblog && !$this->_skipmyblog) {$this->_display = false; return false;}
			//if($comzoo && !$this->_skipzoo){$this->_display = false; return false;}
			//if($comlyftenblog && !$this->_skiplyftenblog) {$this->_display = false; return false;}
			//if($comdjcatalog2 && !$this->_skipdjcatalog2) {$this->_display = false; return false;}
			//if($commagent && !$this->_skipmagent) {$this->_display = false; return false;}


			if ($comcontent && $this->_display) {
				//skip for category view

				if (($jinput->getCmd('view') == 'category') && $this->_skipcatview) {

					$this->_display = false;

					return false;

				}

				//skip for featured view
				if (($jinput->getCmd('view') == 'featured') && $this->_skipcontentlatestview) {
					$this->_display = false;

					return false;
				}


				//category to ignore
				if (isset ($article->catid) && !is_null($this->_skipcat)) {
					if (is_array($this->_skipcat) && in_array($article->catid, $this->_skipcat)) { //if array
						$this->_display = false;

						return false;
					} else if ($this->_skipcat != '' && ($article->catid == $this->_skipcat)) { //for one item it will be string, not empty string
						$this->_display = false;

						return false;
					}
				}//end category ignore
			} else if ($comk2 && $this->_display) {

				//ignore for category layout
				if (($jinput->getCmd('view') == 'latest') && ($jinput->getCmd('layout') == 'latest') && $this->_skipk2latestview) {
					$this->_display = false;

					return false;
				}
				//ignore for category layout
				if (($jinput->getCmd('view') == 'itemlist') && !$this->_skipk2itemlistview) {
					$this->_display = false;

					return false;
				}
				//ignore for category layout
				if (($jinput->getCmd('view') == 'itemlist') && ($jinput->getCmd('layout') == 'category') && $this->_skipk2catview) {
					$this->_display = false;

					return false;
				}

				//ignore for tag/generic layout
				if (($jinput->getCmd('view') == 'itemlist') && ($jinput->getCmd('layout') == 'generic') && $this->_skipk2genericview) {
					$this->_display = false;

					return false;
				}

				//ignore for user layout
				if (($jinput->getCmd('view') == 'itemlist') && ($jinput->getCmd('layout') == 'user') && $this->_skipk2userview) {
					$this->_display = false;

					return false;
				}

				if (isset ($article->catid) && !is_null($this->_skipk2cat)) {
					if (is_array($this->_skipk2cat) && in_array($article->catid, $this->_skipk2cat)) { //if array

						$this->_display = false;

						return false;
					} else if ($this->_skipk2cat != '' && ($article->catid == $this->_skipk2cat)) { //for one item it will be string, not empty string

						$this->_display = false;

						return false;
					}
				}//end category ignore

				if ($params->get('enabledownload') != null) {
					$this->_display = false;

					return false;
				}

			} else if ($comgpstools && $this->_display) {
				if (($jinput->getCmd('view') == 'gpstools') && ($jinput->getCmd('task') == 'viewtrack') && (intval($jinput->getCmd('id')) > 0)) {

				} else {
					$this->_display = false;
					$comgpstools    = false;

					return false;
				}
			}

			//end checking components


			if (!defined('CBLIKEBUTOONJSLOAD')) {
				$doc = JFactory::getDocument();

				$doc->addStyleSheet(JURI::root() . 'plugins/content/cblikebutton/assets/css/cblikebutton.css');

				if ($this->_buttontype == "html") {
					$doc->addStyleSheet(JURI::root() . 'plugins/content/cblikebutton/assets/css/cblikebutton-color.css');
				} else {
					$doc->addStyleSheet(JURI::root() . 'plugins/content/cblikebutton/assets/css/cblikebutton-img.css');
				}

				$extrastyle = '#main .cblikebutton-wrp a:link,
                                        #main .cblikebutton-wrp a:active,
                                        #main .cblikebutton-wrp a:visited,
                                        #main .cblikebutton-wrp a:hover,
                                        #main .cblikebutton-wrp a:hover span.cblikebutton-count,
                                        #main .cblikebutton-wrp a:focus {
                                            background: none;
                                            color: #333333;
                                            cursor: pointer;
                                            /*display: inline-block;*/
                                            /*padding: 5px 10px;*/
                                            text-decoration: none;
                                        }';

				if ($this->_buttontype == "html" && $this->_buttonview == "compact") {
					$extrastyle .= '
                            .cblikebutton-wrp {
                                /*width: 64px;
                                height: 64px;*/
                                height: auto;
                                display: inline-block;
                                position: relative;
                            }

                            .cblikebtn {
                                display: block;
                                line-height: 18px;
                                margin-top: 5px;
                                /*position: absolute;*/
                                width: 42px;
                            }

                            .cblikebutton-count {
                                display: block;
                                height: 28px;
                                line-height: 28px;
                                margin: 0;
                                max-width: 64px;
                                min-width: 18px;
                                padding: 0;
                                position: relative;
                                text-align: center;

                            }

                            .cblikebutton-wrp i {
                                width: 7px;
                                height: 5px;
                                background: url("' . JURI::root() . 'plugins/content/cblikebutton/assets/img/arrow-down.png") no-repeat scroll 0 0 transparent;
                                display: block;
                                position: absolute;
                                left: 8px;
                                margin-top: -2px;

                            }
                    ';
				}


				if ($this->_buttontype == "img") {
					$extrastyle .= '
                   .cblikebutton-wrp {
                        height: auto;
                        position: relative;
                        display: inline-block;
                        visibility: visible;
                   }

                   .cblikebtnimg {
                       /*position: absolute;*/
                       margin-top: 5px;
                       
                       
                   }
                   
                   .cblikebtnimg-custom {
                        background-image: url("' . JURI::root() . $this->_imgbeforelike . '");
                        background-repeat: no-repeat;
                        height:' . $this->_imgheight . 'px;
                        width:' . $this->_imgwidth . 'px;
                        
                   }
                   
                   .cblikebtnimg-custom-after {
                        background-image: url("' . JURI::root() . $this->_imgafterlike . '");
                        background-repeat: no-repeat;
                        height:' . $this->_imgheight . 'px;
                        width:' . $this->_imgwidth . 'px;
                        
                   }


                    .cblikebutton-count {
                        display: block;
                        position: relative;
                        margin: 0;
                        height: 18px;
                        line-height: 18px;
                        max-width: 54px;
                        min-width: 18px;
                        text-align: center;

                    }

                    .cblikebutton-wrp i {
                        width: 7px;
                        height: 5px;
                        background: url("' . JURI::root() . 'plugins/content/cblikebutton/assets/img/arrow-down.png") no-repeat scroll 0 0 transparent;
                        display: block;
                        position: absolute;
                        left: 8px;
                        margin-top: -2px;

                    }';

				}

				$doc->addStyleDeclaration($extrastyle);

				// if ($this->_loadjquery) {
				//     $doc->addScript(JURI::root() . 'plugins/content/cblikebutton/assets/js/cblike.jquery.min.js');
				// }


				JHtml::_('jquery.framework');

				//$doc->addScript(JURI::root() . 'plugins/content/cblikebutton/assets/js/jquery.cookie.js');

				// The new javascript starts here

				if ($this->_likerestrict && $user->id == 0) {
					$guestval = '1';
				} else {
					$guestval = '0';
				}

				$session = JFactory::getSession();
				$token   = $session->getToken();

				$newjscode = '
                var cblikeobj = {
                    btntype: "' . $this->_buttontype . '",
                    detail:"' . $this->_detailcount . '",
                    guest: "' . $guestval . '",
                    staturl:"' . JURI::base() . 'index.php?option=com_cblike&view=cblike&task=cblike.statshow&format=raw&stamp=' . time() . '",
                    comurl: "' . JURI::base() . 'index.php?option=com_cblike&view=cblike&task=cblike.dolike&format=raw&stamp=' . time() . '",
                    dislikeurl: "' . JURI::base() . 'index.php?option=com_cblike&view=cblike&task=cblike.dodislike&format=raw&stamp=' . time() . '",
                    txtbeforelike:"' . $this->_txtbeforelike . '",
                    txtafterlike: "' . $this->_txtafterlike . '",
                    imgstyle: "' . $this->_imgstyle . '",
                    cblikeauth:"' . $token . '",
                    befirst_t: "' . JText::_('PLG_CBLIKEBUTTON_COM_BE_FIRST') . '",
                    nusers_more: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_USERS_MORE') . '",
                    nusers_0: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_USERS_0') . '",
                    nusers_1: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_USERS_1') . '",
                    guest_more: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_GUESTS_MORE') . '",
                    guest_0: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_GUESTS_0') . '",
                    guest_1: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_GUESTS_1') . '",
                    strand: "' . JText::_('PLG_CBLIKEBUTTON_COM_N_AND') . '",
                    alreadyvoted:"'.JText::_('PLG_CBLIKEBUTTON_ALREADYVOTED').'",
                    ajaxresponseerror: "' . JText::_('PLG_CBLIKEBUTTON_COM_CBLIKE_AJAX_RESPONSE_ERROR') . '"

                };';

				$doc->addScriptDeclaration($newjscode);
				$doc->addScript(JURI::root() . 'plugins/content/cblikebutton/assets/js/cblikebuttonjs.js');

				// End of new javascript.

				define('CBLIKEBUTOONJSLOAD', 1);
			}


			return true;

		}


		/**
		 * [onContentPrepare description]
		 * @param  [type] $context
		 * @param  [type] $article
		 * @param  [type] $params
		 * @param  [type] $limitstart
		 * @return [type]
		 */
		public function onContentPrepare($context, &$article, &$params, $limitstart = 0)
		{
			$app    = JFactory::getApplication();
			$jinput = $app->input;


			if (($jinput->getCmd('option') == 'com_gpstools') && ($jinput->getCmd('view') == 'gpstools') && ($jinput->getCmd('task') == 'viewtrack') && (intval($jinput->getCmd('id')) > 0)) {
				if ($this->_LikeButtonGate($context, $article, $params, $limitstart = null)) {
					//if ($this->_buttonpos == 'before') {
					$ext  = $jinput->getVar('option');
					$view = 'viewtrack';

					$id     = intval($jinput->getCmd('id'));
					$itemid = $id;

					$button = $this->_buttonrender($ext, $view, $itemid, $context);
					if ($this->_buttonpos == 'before') {
						$article->text = $button . $article->text;
					} else {
						$article->text = $article->text . $button;
					}

				}
			}


		}// end of function onContentPrepare


		public function onContentBeforeDisplay($context, &$article, &$params, $limitstart = 0)
		{

			$app    = JFactory::getApplication();
			$jinput = $app->input;

			if (!$this->_display) return '';
			if ($this->_LikeButtonGate($context, $article, $params, $limitstart = null)) {
				if ($this->_buttonpos == 'before') {
					$ext  = $jinput->getVar('option');
					$view = $this->getArticleViewFromContext($context);

					$itemid = $article->id;

					return $this->_buttonrender($ext, $view, $itemid, $context);
				}
			}
		}// end of function onContentBeforeDisplay


		public function onContentAfterDisplay($context, &$article, &$params, $limitstart = 0)
		{
			$app    = JFactory::getApplication();
			$jinput = $app->input;
			if (!$this->_display) return '';
			if ($this->_LikeButtonGate($context, $article, $params, $limitstart = null)) {
				if ($this->_buttonpos == 'after') {
					$ext  = $jinput->getVar('option');
					$view = $this->getArticleViewFromContext($context);

					$itemid = $article->id;

					return $this->_buttonrender($ext, $view, $itemid, $context);
				}
			}

		}


		private function getArticleViewFromContext($context)
		{


			$views = array(
				'com_content'    => 'article',
				'com_k2'         => 'item',
				'com_gpstools'   => 'viewtrack',
				'com_virtuemart' => 'productdetails',
				'com_hikashop'   => ''
			);

			$context = explode('.', $context);

			return $views[$context[0]];


		}

		/**
		 * Detection mobile
		 */
		function _check_mobile_device()
		{
			$user_agent = strtolower($_SERVER['HTTP_USER_AGENT']);
			$accept     = strtolower($_SERVER['HTTP_ACCEPT']);

			if (
				0
				or preg_match('/ip[ao]d/', $user_agent)
				or preg_match('/iphone/', $user_agent) //iPhone or iPod
				or preg_match('/android/', $user_agent) //Android
				or preg_match('/opera mini/', $user_agent) //Opera Mini
				or preg_match('/blackberry/', $user_agent) //Blackberry
				or preg_match('/series ?60/', $user_agent) //Symbian OS
				or preg_match('/(pre\/|palm os|palm|hiptop|avantgo|plucker|xiino|blazer|elaine)/', $user_agent) //Palm OS
				or preg_match('/(iris|3g_t|windows ce|opera mobi|iemobile)/', $user_agent) //Windows OS
				or preg_match('/(maemo|tablet|qt embedded|com2)/', $user_agent) //Nokia Tablet
			) {
				return true;
			}
			/**
			 * Now look for standard phones & mobile devices
			 */
			//Mix of standard phones
			if (preg_match('/(mini 9.5|vx1000|lge |m800|e860|u940|ux840|compal|wireless| mobi|ahong|lg380|lgku|lgu900|lg210|lg47|lg920|lg840|lg370|sam-r|mg50|s55|g83|t66|vx400|mk99|d615|d763|el370|sl900|mp500|samu3|samu4|vx10|xda_|samu5|samu6|samu7|samu9|a615|b832|m881|s920|n210|s700|c-810|_h797|mob-x|sk16d|848b|mowser|s580|r800|471x|v120|rim8|c500foma:|160x|x160|480x|x640|t503|w839|i250|sprint|w398samr810|m5252|c7100|mt126|x225|s5330|s820|htil-g1|fly v71|s302|-x113|novarra|k610i|-three|8325rc|8352rc|sanyo|vx54|c888|nx250|n120|mtk |c5588|s710|t880|c5005|i;458x|p404i|s210|c5100|teleca|s940|c500|s590|foma|samsu|vx8|vx9|a1000|_mms|myx|a700|gu1100|bc831|e300|ems100|me701|me702m-three|sd588|s800|8325rc|ac831|mw200|brew |d88|htc\/|htc_touch|355x|m50|km100|d736|p-9521|telco|sl74|ktouch|m4u\/|me702|8325rc|kddi|phone|lg |sonyericsson|samsung|240x|x320|vx10|nokia|sony cmd|motorola|up.browser|up.link|mmp|symbian|smartphone|midp|wap|vodafone|o2|pocket|kindle|mobile|psp|treo|vnd.rim|wml|nitro|nintendo|wii|xbox|archos|openweb|mini|docomo)/', $user_agent)) {
				return true;
			}
			//Any falling through the cracks
			if (
				0
				or strpos($accept, 'text/vnd.wap.wml') > 0
				or strpos($accept, 'application/vnd.wap.xhtml+xml') > 0
				or isset($_SERVER['HTTP_X_WAP_PROFILE'])
				or isset($_SERVER['HTTP_PROFILE'])
			) {
				return true;
			}
			//Catch all
			if (
			in_array(
				substr($user_agent, 0, 4),
				array(
					'1207', '3gso', '4thp', '501i', '502i', '503i', '504i', '505i', '506i', '6310',
					'6590', '770s', '802s', 'a wa', 'acer', 'acs-', 'airn', 'alav', 'asus', 'attw',
					'au-m', 'aur ', 'aus ', 'abac', 'acoo', 'aiko', 'alco', 'alca', 'amoi', 'anex',
					'anny', 'anyw', 'aptu', 'arch', 'argo', 'bell', 'bird', 'bw-n', 'bw-u', 'beck',
					'benq', 'bilb', 'blac', 'c55/', 'cdm-', 'chtm', 'capi', 'cond', 'craw', 'dall',
					'dbte', 'dc-s', 'dica', 'ds-d', 'ds12', 'dait', 'devi', 'dmob', 'doco', 'dopo',
					'el49', 'erk0', 'esl8', 'ez40', 'ez60', 'ez70', 'ezos', 'ezze', 'elai', 'emul',
					'eric', 'ezwa', 'fake', 'fly-', 'fly_', 'g-mo', 'g1 u', 'g560', 'gf-5', 'grun',
					'gene', 'go.w', 'good', 'grad', 'hcit', 'hd-m', 'hd-p', 'hd-t', 'hei-', 'hp i',
					'hpip', 'hs-c', 'htc ', 'htc-', 'htca', 'htcg', 'htcp', 'htcs', 'htct', 'htc_',
					'haie', 'hita', 'huaw', 'hutc', 'i-20', 'i-go', 'i-ma', 'i230', 'iac', 'iac-',
					'iac/', 'ig01', 'im1k', 'inno', 'iris', 'jata', 'java', 'kddi', 'kgt', 'kgt/',
					'kpt ', 'kwc-', 'klon', 'lexi', 'lg g', 'lg-a', 'lg-b', 'lg-c', 'lg-d', 'lg-f',
					'lg-g', 'lg-k', 'lg-l', 'lg-m', 'lg-o', 'lg-p', 'lg-s', 'lg-t', 'lg-u', 'lg-w',
					'lg/k', 'lg/l', 'lg/u', 'lg50', 'lg54', 'lge-', 'lge/', 'lynx', 'leno', 'm1-w',
					'm3ga', 'm50/', 'maui', 'mc01', 'mc21', 'mcca', 'medi', 'meri', 'mio8', 'mioa',
					'mo01', 'mo02', 'mode', 'modo', 'mot ', 'mot-', 'mt50', 'mtp1', 'mtv ', 'mate',
					'maxo', 'merc', 'mits', 'mobi', 'motv', 'mozz', 'n100', 'n101', 'n102', 'n202',
					'n203', 'n300', 'n302', 'n500', 'n502', 'n505', 'n700', 'n701', 'n710', 'nec-',
					'nem-', 'newg', 'neon', 'netf', 'noki', 'nzph', 'o2 x', 'o2-x', 'opwv', 'owg1',
					'opti', 'oran', 'p800', 'pand', 'pg-1', 'pg-2', 'pg-3', 'pg-6', 'pg-8', 'pg-c',
					'pg13', 'phil', 'pn-2', 'pt-g', 'palm', 'pana', 'pire', 'pock', 'pose', 'psio',
					'qa-a', 'qc-2', 'qc-3', 'qc-5', 'qc-7', 'qc07', 'qc12', 'qc21', 'qc32', 'qc60',
					'qci-', 'qwap', 'qtek', 'r380', 'r600', 'raks', 'rim9', 'rove', 's55/', 'sage',
					'sams', 'sc01', 'sch-', 'scp-', 'sdk/', 'se47', 'sec-', 'sec0', 'sec1', 'semc',
					'sgh-', 'shar', 'sie-', 'sk-0', 'sl45', 'slid', 'smb3', 'smt5', 'sp01', 'sph-',
					'spv ', 'spv-', 'sy01', 'samm', 'sany', 'sava', 'scoo', 'send', 'siem', 'smar',
					'smit', 'soft', 'sony', 't-mo', 't218', 't250', 't600', 't610', 't618', 'tcl-',
					'tdg-', 'telm', 'tim-', 'ts70', 'tsm-', 'tsm3', 'tsm5', 'tx-9', 'tagt', 'talk',
					'teli', 'topl', 'hiba', 'up.b', 'upg1', 'utst', 'v400', 'v750', 'veri', 'vk-v',
					'vk40', 'vk50', 'vk52', 'vk53', 'vm40', 'vx98', 'virg', 'vite', 'voda', 'vulc',
					'w3c ', 'w3c-', 'wapj', 'wapp', 'wapu', 'wapm', 'wig ', 'wapi', 'wapr', 'wapv',
					'wapy', 'wapa', 'waps', 'wapt', 'winc', 'winw', 'wonu', 'x700', 'xda2', 'xdag',
					'yas-', 'your', 'zte-', 'zeto', 'acs-', 'alav', 'alca', 'amoi', 'aste', 'audi',
					'avan', 'benq', 'bird', 'blac', 'blaz', 'brew', 'brvw', 'bumb', 'ccwa', 'cell',
					'cldc', 'cmd-', 'dang', 'doco', 'eml2', 'eric', 'fetc', 'hipt', 'http', 'ibro',
					'idea', 'ikom', 'inno', 'ipaq', 'jbro', 'jemu', 'java', 'jigs', 'kddi', 'keji',
					'kyoc', 'kyok', 'leno', 'lg-c', 'lg-d', 'lg-g', 'lge-', 'libw', 'm-cr', 'maui',
					'maxo', 'midp', 'mits', 'mmef', 'mobi', 'mot-', 'moto', 'mwbp', 'mywa', 'nec-',
					'newt', 'nok6', 'noki', 'o2im', 'opwv', 'palm', 'pana', 'pant', 'pdxg', 'phil',
					'play', 'pluc', 'port', 'prox', 'qtek', 'qwap', 'rozo', 'sage', 'sama', 'sams',
					'sany', 'sch-', 'sec-', 'send', 'seri', 'sgh-', 'shar', 'sie-', 'siem', 'smal',
					'smar', 'sony', 'sph-', 'symb', 't-mo', 'teli', 'tim-', 'tosh', 'treo', 'tsm-',
					'upg1', 'upsi', 'vk-v', 'voda', 'vx52', 'vx53', 'vx60', 'vx61', 'vx70', 'vx80',
					'vx81', 'vx83', 'vx85', 'wap-', 'wapa', 'wapi', 'wapp', 'wapr', 'webc', 'whit',
					'winw', 'wmlb', 'xda-'
				)
			)
			) {
				return true;
			}

			return false;
		}// end of _check_mobile_device

		//end of function onContentAfterDisplay

		public function _buttonrender($ext, $view, $itemid, $context)
		{

			//var_dump('hi there');

			//load language
			JPlugin::loadLanguage('plg_content_cblikebutton', JPATH_ADMINISTRATOR);

			$app 		= JFactory::getApplication();


			//cookie time and logmethod
			$this->_cookietime = intval($this->params->get('cookietime', 1));  // day
			$this->_logmethod  = intval($this->params->get('logmethod', 2));  // 2 = both, 1 = cookie  , 0 = ip


			if ($this->_cookietime == 0) $this->_cookietime = 1; //safe side




			defined('CBX_LIKE_COOKIE_SET') or CbLikeHelper::init_cookie($this->_cookietime);


			$data    = new CbLikeModelCbLike;
			$user    = JFactory::getUser();

			$user_session = $cookie_value = $_COOKIE[CBX_LIKE_COOKIE_NAME];;



			$user_ip = CbLikeHelper::get_ipaddress();
			$user_id = $user->id;

			$isvoted = $data->isVoted($this->_logmethod, $user_ip, $user_id, $user_session, $ext, $view, $itemid);


			$stat = json_decode($data->getShowcount($ext, $view, $itemid), true);

			$userstat = json_decode($stat['usernames'], true);

			if (empty($userstat)) $userstat = array();


			$buttonhtml = '';

			$buttonhtml .= '<div class="cblikebutton-wrp">';
			$mute = ($isvoted > 0) ? 1 : 0;

			$this->_imgstyle = ($isvoted > 0) ? $this->_imgstyle . '-after' : $this->_imgstyle;
			$disabled_label  = ($isvoted > 0) ? ' disabled ' : '';


			if ($user_id > 0) {
				//logged in user


				//logged in and voted
				$buttonhtml .= '<a href="#" class="cblikebutton-anchor" data-mute="' . $mute . '" data-summary="' . base64_encode($ext . '-' . $view . '-' . $itemid) . '">';

				if ($this->_buttontype == "html" && $this->_buttonview == "normal") {

					$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . (($mute)? $this->_txtafterlike: $this->_txtbeforelike) . '</span>';
					$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';

				} elseif ($this->_buttontype == "html" && $this->_buttonview == "compact") {


					$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';
					$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . (($mute)? $this->_txtafterlike: $this->_txtbeforelike) . '</span>';

				} else {

					$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';

					$buttonhtml .= '<div title="'.(($mute)? $this->_txtafterlike: $this->_txtbeforelike).'" class="cblikebtnimg cblikebtnimg-' . $this->_imgstyle . ' ' . $disabled_label . '"></div>';

				}
				$buttonhtml .= '</a>';



			} else {
				//guest user


				if ($this->_likerestrict && $this->_guestbutton) {
					//guest can not vote but see the vote vote button with msg

					//var_dump('hi there');
					//var_dump($mute);

					$buttonhtml .= '<a href="#" title="' . JText::_('PLG_CBLIKEBUTTON_COM_CBLIKE_LOGIN_ALERT') . '"  class="cblikebutton-anchor-guest" style="background:none;" data-mute="' . $mute . '" >';

					if ($this->_buttontype == "html" && $this->_buttonview == "normal") {

						$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . $this->_txtbeforelike . '</span>';
						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';

					} elseif ($this->_buttontype == "html" && $this->_buttonview == "compact") {

						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';
						$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . $this->_txtbeforelike . '</span>';

					} else {

						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';
						$buttonhtml .= '<div class="cblikebtnimg cblikebtnimg-' . $this->_imgstyle . '' . $disabled_label . ' "></div>';

					}

					//$buttonhtml .='<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span></a>';
					$buttonhtml .= '</a>';
				}

				if ($this->_likerestrict == 0) {
					//guest can vote

					//var_dump($mute);

					//non loggedin and didn't vote
					$buttonhtml .= '<a href="#" class="cblikebutton-anchor" data-mute="' . $mute . '" data-summary="' . base64_encode($ext . '-' . $view . '-' . $itemid) . '">';

					if ($this->_buttontype == "html" && $this->_buttonview == "normal") {

						$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . (($mute)? $this->_txtafterlike: $this->_txtbeforelike) . '</span>';
						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';

					} elseif ($this->_buttontype == "html" && $this->_buttonview == "compact") {

						//$buttonhtml .='<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span><i></i>';
						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';
						$buttonhtml .= '<span class="cblikebtn cblikebtn-small ' . ($this->_htmlbtncolor ? 'cblikebtn-' . $this->_htmlbtncolor : '') . ' ' . $disabled_label . '">' . (($mute)? $this->_txtafterlike: $this->_txtbeforelike) . '</span>';

					} else {

						//$buttonhtml .='<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span><i></i>';
						$buttonhtml .= '<span class="cblikebutton-count">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';
						$buttonhtml .= '<div title="'.(($mute)? $this->_txtafterlike: $this->_txtbeforelike).'" class="cblikebtnimg cblikebtnimg-' . $this->_imgstyle . ' ' . $disabled_label . ' ' . $disabled_label . '"></div>';

					}
					$buttonhtml .= '</a>';
				}

			}


			if ($this->_detailcount) {

				if ($stat['likecount'] > 0) {

					//$lang = JFactory::getLanguage();


					$userlike  = ((int)$stat['likecount'] ? (int)$stat['likecount'] - (int)$stat['guestlike'] : (int)$stat['likecount']);
					$guestlike = (int)$stat['guestlike'];

					$buttonhtml .= '<p class="cblikestatmsg">';
					$buttonhtml .= JText::plural("PLG_CBLIKEBUTTON_COM_N_USERS", $userlike);
					$buttonhtml .= JText::_("PLG_CBLIKEBUTTON_COM_N_AND");
					$buttonhtml .= JText::plural("PLG_CBLIKEBUTTON_COM_N_GUESTS", $guestlike);
					$buttonhtml .= '</p>';


				} else {

					$buttonhtml .= '<p class="cblikestatmsg" style="font-style:italic;">' . sprintf(JText::_('PLG_CBLIKEBUTTON_COM_BE_FIRST'), strtolower($this->_txtbeforelike)) . '</p>';

				}

			} else {

				$buttonhtml .= '<p class="cblikestatmsg"></p>';
			}

			$buttonhtml .= '</div>';


			return $buttonhtml;
		}// end of function _buttonrender


	}// end of class plgContentCblikebutton