<?php
    /**
     * CBX Like Most Popular
     *
     * @version   1.0
     * @package   mod_cblikemostpop
     * @author    Codeboxr team ( http://codeboxr.com )
     * @copyright Copyright (C) 2011-2015 http://codeboxr.com. All rights reserved.
     * @license   http://www.gnu.org/copyleft/gpl.html GNU/GPL
     * @help http://codeboxr.com/product/standalone-like-system-for-joomla
     */


// no direct access
    defined('_JEXEC') or die('Restricted access');




    if (JFile::exists(JPATH_BASE . '/components/com_k2/helpers/route.php')) {
        require_once JPATH_BASE . '/components/com_k2/helpers/route.php';
    }
    if (JFile::exists(JPATH_BASE . '/components/com_content/helpers/route.php')) {
        require_once JPATH_BASE . '/components/com_content/helpers/route.php';
    }

//


//require_once JPATH_BASE.'/components/com_cblike/model/cblike.php';

    class modCblikemostpop {

        /**
         *
         *
         * @param int $count
         * @param     $extlist
         *
         * @return mixed
         */
        public static function getLikes($count = 5, $extlist) {

            $ext = implode('\',\'', $extlist);

            //var_dump($ext);

            $db    = JFactory::getDbo();
            $query = $db->getQuery(true);

            $query->select("extensionname");
            $query->select("itemid");
            $query->select("likecount");
            $query->select("viewname");
            $query->from("#__cbliker_likesummary");
            $query->where("extensionname IN ('$ext')");

            $query->order("likecount" . " DESC");

            $db->setQuery($query, 0, $count);

            $result = $db->loadObjectList();

            return $result;

        } // End of function getLikes


        /**
         * @param $id
         *
         * @return mixed
         */
        public static function getArticleInfo($id) {

            $db = JFactory::getDbo();

            $query = $db->getQuery(true);

            $query->select("a.title");

            $query->select("a.alias");

            $query->select("a.introtext");

            $query->select("a.fulltext");

            $query->select("a.images");

            $query->select("a.catid");

            $query->from("#__content AS a");

            $query->select("c.alias AS category_alias");

            $query->join("LEFT", "#__categories AS c on c.id = a.catid");

            $query->where("a.id = $id");

            $query->where("a.state = 1");

            $db->setQuery($query, 0, 5);

            $result = $db->loadObject();

            return $result;

        }

        /**
         *
         *
         * @param $id
         *
         * @return mixed
         */
        static function getK2itemInfo($id) {

            $db    = JFactory::getDbo();
            $query = $db->getQuery(true);

            $query->select("a.title");

            $query->select("a.alias");

            $query->select("a.introtext");
            $query->select("a.fulltext");

            $query->select("a.catid");

            $query->from("#__k2_items AS a");

            $query->select("c.alias AS category_alias");

            $query->join("LEFT", "#__k2_categories AS c on c.id = a.catid");

            $query->where("a.id = $id");

            $query->where("a.published = 1");

            $db->setQuery($query, 0, 5);

            $result = $db->loadObject();

            //var_dump($result);

            return $result;
        }

        static function getVProductInfo($id) {


            $lang   = JFactory::getLanguage();
            $vmlang = $lang->getDefault();
            $vmlang = strtolower(strtr($vmlang, '-', '_'));
            $db     = JFactory::getDbo();

            $query = $db->getQuery(true);

            $query->select("a.product_name AS title");

            $query->select("a.slug AS alias");

            $query->select("a.product_s_desc AS introtext");

            $query->select("a.product_desc AS vdesc");

            $query->select("c.virtuemart_category_id AS catid");

            $query->select("cd.slug AS category_alias");

            $query->select("vm.file_url AS images");

            $query->from("#__virtuemart_products_$vmlang AS a");

            //$query->select("c.alias AS virtuemart_category_id");

            $query->join("LEFT", "#__virtuemart_products AS p on p.virtuemart_product_id = p.virtuemart_product_id");

            $query->join("LEFT", "#__virtuemart_product_categories AS c on c.virtuemart_product_id = a.virtuemart_product_id");

            $query->join("LEFT", "#__virtuemart_categories_$vmlang AS cd on cd.virtuemart_category_id = c.virtuemart_category_id");

            $query->join("LEFT", "#__virtuemart_product_medias AS vpm on vpm.virtuemart_product_id = p.virtuemart_product_id");

            $query->join("LEFT", "#__virtuemart_medias AS vm on vpm.virtuemart_media_id = vm.virtuemart_media_id");

            $query->where("a.virtuemart_product_id = $id");

            $query->where("p.published = 1");

            $db->setQuery($query, 0, 5);

            $result = $db->loadObject();

//        var_dump($result);
//        
//        exit(1);
            return $result;
        }


        function getHikaProductInfo($id) {


            $db = & JFactory::getDbo();

            $query = $db->getQuery(true);

            $query->select("a.product_name AS title");

            $query->select("a.product_alias AS alias");

            $query->select("a.product_description AS introtext");

            $query->select("c.category_id AS catid");

            $query->select("cd.category_alias AS category_alias");

            $query->from("#__hikashop_product AS a");

            //$query->select("c.alias AS virtuemart_category_id");

            $query->join("LEFT", "#__hikashop_product AS p on p.product_id = p.product_id");

            $query->join("LEFT", "#__hikashop_product_category AS c on c.product_id = a.product_id");

            $query->join("LEFT", "#__hikashop_category AS cd on cd.category_id = c.category_id");

            $query->where("a.product_id = $id");

            $query->where("p.product_published = 1");

            $db->setQuery($query, 0, 5);

            $result = $db->loadObject();

            return $result;
        }

        /**
         *
         *
         * @param $ext
         * @param $view
         * @param $itemid
         * @param $params
         *
         * @return string
         */
        public static function _buttonrender($ext, $view, $itemid, $params) {

            $plugin = JPluginHelper::getPlugin('content', 'cblikebutton');

            //var_dump($plugin);

            $plgParams = new JRegistry($plugin->params);

            //var_dump($plgParams);

            //Basic Params
            $_incontent = (bool)$plgParams->get('enablecontent', 1); //show/hide for specific itemid
            $_ink2      = (bool)$plgParams->get('enablek2', 0);
            $_invm      = (bool)$plgParams->get('enablevm', 0);
            $_inhshop   = (bool)$plgParams->get('enablehikashop', 0);

            $_buttonpos    = $plgParams->get('buttonpos', 'before'); // 0 exclude  1 include   (only)
            $_likerestrict = (bool)$plgParams->get('likerestrict', 0);
            $_guestbutton  = (bool)$plgParams->get('guestbutton', 0);
            //$_loadjquery   = (bool) $plgParams->get('loadjquery', 1);

            $_skipitemids      = $plgParams->get('skipitemid', '');
            $_itemidfiltertype = $plgParams->get('itemidfiltertype', 1); // 0 exclude  1 include   (only)
            $_curitemid        = JRequest::getCmd('Itemid', '');

            //for com_content component
            //$_skipcontent        = $plgParams->get('skipcontent', 1); //works with com_content, default enabled
            $_skipcat      = $plgParams->get('skipcat', NULL); //show hide for specific categories
            $_skipcatview  = $plgParams->get('skipcatview', 0); // show/hide in category view
            $_skipcatsview = $plgParams->get('skipcatsview', 0); // show/hide in categories view
            //for com_k2 component
            $_skipk2cat = $plgParams->get('skipk2cat', NULL); //show hide for specific categories

            $_skipk2catview      = $plgParams->get('skipk2catview', 1); // show/hide in category view, default no 0
            $_skipk2latestview   = $plgParams->get('skipk2latestview', 1); // show/hide in latest view
            $_skipk2itemlistview = $plgParams->get('skipk2itemlistview', 1); // show/hide in itemlist
            $_skipk2genericview  = $plgParams->get('skipk2genericview', 1); // shows/hide in tag view
            $_skipk2userview     = $plgParams->get('skipk2userview', 1); // show/hide in category view
            //Button Features
            $_countbtnpos = $plgParams->get('countbtnpos', 'right');


            $_buttontype    = $params->get('buttontype', 'html');
            $_htmlbtncolor  = $params->get('htmlbtncolor', '');
            $_buttonview    = $params->get('buttonview', 'normal');
            $_txtbeforelike = $params->get('txtbeforelike', 'Like');
            $_txtafterlike  = $params->get('txtafterlike', 'Liked!');
            $_imgstyle      = $params->get('imgstyle', 'thumb-square');
            $_imgbeforelike = $params->get('imgbeforelike', '');
            $_imgafterlike  = $params->get('imgafterlike', '');
            $_imgwidth      = $params->get('imgwidth', '');
            $_imgheight     = $params->get('imgheight', '');

            $_detailcount = $params->get('detailcount', 0);

            //var_dump($_detailcount);

            $user = JFactory::getUser();

            //var_dump(($_likerestrict && empty($user->username)));
            $_username = $user->username;
            $_userid   = $user->id;
            $_user     = $user->username . ':' . $user->id;


            //
            if (!defined('CBLIKEBUTOONJSMODLOAD')) {
                $doc = JFactory::getDocument();

                $doc->addStyleSheet(JURI::root() . 'modules/mod_cblikemostpop/assets/css/cblikebutton.css');


                $extrastyle = '#main .cblikebuttonmod-wrp a:link,
                                    #main .cblikebuttonmod-wrp a:active,
                                    #main .cblikebuttonmod-wrp a:visited,
                                    #main .cblikebuttonmod-wrp a:hover,
                                    #main .cblikebuttonmod-wrp a:hover span.cblikebuttonmod-count,
                                    #main .cblikebuttonmod-wrp a:focus {
                                        background: none;
                                        color: #333333;
                                        cursor: pointer;
                                        /*display: inline-block;*/
                                        /*padding: 5px 10px;*/
                                        text-decoration: none;
                                    }';


                //$doc->addStyleDeclaration($extrastyle);



                define('CBLIKEBUTOONJSMODLOAD', 1);
            }


            $data = new CbLikeModelCbLike;

            //$stat       =   $data->getShowcount($ext, $view, $itemid);

            $stat = json_decode($data->getShowcount($ext, $view, $itemid), true);

            //var_dump($stat);

            $userstat = json_decode($stat['usernames'], true);

            if (empty($userstat))
                $userstat = array();


            $buttonhtml = '';


            $buttonhtml .= '<span class="cblikebuttonmod-c">' . ((int)$stat['likecount'] ? (int)$stat['likecount'] : 0) . '</span>';


            return $buttonhtml;
        }

        public static function renderContent($params) {

            $count = $params->get('articlecount', 5);

            $comenable = array();
            if ($params->get('showcontent', 1)) $comenable[] = 'com_content';
            if ($params->get('showk2', 1)) $comenable[] = 'com_k2';
            if ($params->get('showvmart', 1)) $comenable[] = 'com_virtuemart';
            if ($params->get('showhika', 1)) $comenable[] = 'com_hikashop';


            //var_dump($comenable);

            //getting most liked articles
            $articles = self::getLikes($count, $comenable);

            //var_dump($articles);

            $i       = 0;
            $content = array();

            foreach ($articles as $article) {

                switch ($article->extensionname) {

                    case 'com_content' :

                        if (!in_array('com_content', $comenable)) continue;

                        $articleinfo = self::getArticleInfo($article->itemid);


                        break;

                    case 'com_k2' :

                        if (!in_array('com_k2', $comenable)) continue;

                        $articleinfo = self::getK2itemInfo($article->itemid);
                        break;

                    case 'com_virtuemart' :

                        if (!in_array('com_virtuemart', $comenable)) continue;

                        $articleinfo = self::getVProductInfo($article->itemid);
                        //echo "<pre>";var_dump($articleinfo);echo "</pre>";

                        break;

                    case 'com_hikashop' :

                        if (!in_array('com_hikashop', $comenable)) continue;

                        $articleinfo = self::getHikaProductInfo($article->itemid);
                        break;

                    default:

                        $articleinfo = NULL;
                        break;
                }

                if (empty($articleinfo)) continue; // if empty, loop step skips and continues from next one

                $content[$i]['id'] = $article->itemid;

                $slug    = ($articleinfo->alias ? $article->itemid . ':' . $articleinfo->alias : $article->itemid);
                $catslug = $articleinfo->category_alias ? ($articleinfo->catid . ':' . $articleinfo->category_alias) : $articleinfo->catid;

                if ($article->extensionname == 'com_content') {
                    $content[$i]['url']    = JRoute::_(ContentHelperRoute::getArticleRoute($slug, $catslug));
                    $content[$i]['button'] = self::_buttonrender($article->extensionname, $article->viewname, $article->itemid, $params);
                   // echo "<pre>";var_dump($articleinfo);echo "</pre>";


                    $contentimage = '';
                    if (!empty($articleinfo->images)) {
                        $imagearray = json_decode($articleinfo->images);

                        if (!empty($imagearray->image_intro)) {
                            $contentimage = $imagearray->image_intro;

                        } elseif ((!empty($imagearray->image_fulltext)) && empty($imagearray->image_intro)) {
                            $contentimage = $imagearray->image_fulltext;

                        } elseif ((empty($imagearray->image_fulltext)) && empty($imagearray->image_intro)) {
                            $image_article = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->introtext, $matches) ? true : preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->fulltext, $matches);
                            $contentimage  = $image_article ? $matches[1][0] : '';
                        }
                        if($contentimage != ""){
                            $contentimage = JUri::root() . $contentimage;
                        }
                    }


                    $content[$i]['image'] = $contentimage;

                } elseif ($article->extensionname == 'com_k2') {


                    $k2image               = '';
                    $content[$i]['url']    = JRoute::_(K2HelperRoute::getItemRoute($slug, $catslug));
                    $content[$i]['button'] = self::_buttonrender($article->extensionname, $article->viewname, $article->itemid, $params);

                    $thumbtempsrc = JPATH_ROOT . DIRECTORY_SEPARATOR . 'media' . DIRECTORY_SEPARATOR . 'k2' . DIRECTORY_SEPARATOR . 'items' . DIRECTORY_SEPARATOR . 'cache' . DIRECTORY_SEPARATOR . md5("Image" . $article->itemid) . '_L.jpg';

                    if (JFile::exists($thumbtempsrc)) {
                        $k2image = JUri::root() . 'media/k2/items/cache/' . md5('Image' . $article->itemid) . '_L.jpg';
                    } else {
                        $image_article = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->introtext, $matches) ? true : preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->fulltext, $matches);
                        $image         = $image_article ? $matches[1][0] : '';
                        $articleimage  = $image ? $image : '';

                        if ($articleimage && strpos($articleimage, 'http') === false) {
                            $k2image = JURI::base() . $articleimage;
                        }
                    }

                    $content[$i]['image'] = $k2image;

                } elseif ($article->extensionname == 'com_virtuemart') {
	                $vmitemid = intval($params->get('vmdefaultmenu', ''));
	                if($vmitemid > 0){
		                $vmitemid = '&Itemid='.$vmitemid;
	                }
	                else $vmitemid = '';
                    $content[$i]['url']    = JRoute::_('index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $article->itemid . '&virtuemart_category_id=' . $articleinfo->catid.$vmitemid);
                    $content[$i]['button'] = self::_buttonrender($article->extensionname, $article->viewname, $article->itemid, $params);

                    $virtuemart_image = '';
                    if (!empty($articleinfo->images)) {
                        $virtuemart_image = $articleinfo->images;
                    }else{

                        //$image_article = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->introtext, $matches) ? true : preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->vdesc, $matches);
                        $image_article = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $articleinfo->vdesc, $matches) ? true : false;
                        $virtuemart_image  = $image_article ? $matches[1][0] : '';
                    }

                    $content[$i]['image']  = ($virtuemart_image != '' ) ? JUri::root() .$virtuemart_image : '';

                } elseif ($article->extensionname == 'com_hikashop') {
                    $content[$i]['url']    = JRoute::_('index.php?option=com_hikashop&ctrl=product&cid=' . $article->itemid . '&task=show');
                    $content[$i]['button'] = self::_buttonrender($article->extensionname, $article->viewname, $article->itemid, $params);
                }

                $content[$i]['title']     = $articleinfo->title;
                $content[$i]['introtext'] = $articleinfo->introtext;
                $content[$i]['viewname']  = $article->viewname;
                $content[$i]['likecount'] = $article->likecount;

                $i++;
            }

            return $content;

        } // End of function renderContent


    } // End of Class modCblikemostpop

