<?php
	/*------------------------------------------------------------------------
	# cblikehelper.php - Stand Alone Like Component
	# ------------------------------------------------------------------------
	# author    Joomboxr Team
	# copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved
	# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
	# Support Forum   http://joomboxr.com/product/cbx-like/
	-------------------------------------------------------------------------*/

// No direct access to this file
	defined('_JEXEC') or die('Restricted access');


	/**
	 * Helper Method
	 */
	abstract class  CbLikeHelper
	{

		/**
		 * Cookie initialization for the every user
		 */
		public static function init_cookie($day = 1)
		{


			defined('CBX_LIKE_RAND_MIN') or define('CBX_LIKE_RAND_MIN', 0);
			defined('CBX_LIKE_RAND_MAX') or define('CBX_LIKE_RAND_MAX', 999999);


			defined('CBX_LIKE_COOKIE_EXPIRATION') or define('CBX_LIKE_COOKIE_EXPIRATION', time() + (86400 * $day)); //Expiration of 1 day in sec

			defined('CBX_LIKE_COOKIE_NAME') or define('CBX_LIKE_COOKIE_NAME', 'cbxlike-cookie-session');


			$app     = JFactory::getApplication();
			$user               = JFactory::getUser();


			$config = JFactory::getConfig();
			$cookie_domain = $config->get('cookie_domain', '');
			$cookie_path = $config->get('cookie_path', '/');

			//var_dump($site_cookie_domain);

			//if ($site_cookie_domain == null) $site_cookie_domain = $_SERVER['HTTP_HOST'];
			//if ($site_cookie_path == null) $site_cookie_path = '/';


			//var_dump($site_cookie_domain);


			//$jinput  = $app->input;
			//$jcookie = $jinput->cookie;


			//$cookie_value = $app->input->cookie->get(CBX_LIKE_COOKIE_NAME); // Get cookie data  ($name, $defaultValue)

			//var_dump($cookie_value);

			if (!isset($_COOKIE[CBX_LIKE_COOKIE_NAME])) {

				if ($user->id > 0) {
					$cookie_value = 'user-' . $user->id;
				} else {
					//for guest
					$cookie_value = 'guest-' . rand(CBX_LIKE_RAND_MIN, CBX_LIKE_RAND_MAX);				}


				//$jcookie->set( CBX_LIKE_COOKIE_NAME, $cookie_value, CBX_LIKE_COOKIE_EXPIRATION, $site_cookie_path , $site_cookie_domain, $app->isSSLConnection()); // Set cookie data ($name, $value, $expire) $expire == 0: cookie lifetime is of browser session.
				setcookie(CBX_LIKE_COOKIE_NAME, $cookie_value, CBX_LIKE_COOKIE_EXPIRATION, $cookie_path , $cookie_domain, $app->isSSLConnection());



				//$_COOKIE var accepts immediately the value so it will be retrieved on page first load.
				$_COOKIE[CBX_LIKE_COOKIE_NAME] = $cookie_value;
				define('CBX_LIKE_COOKIE_SET', 1);

			}




			//$cookie_value = $jcookie->getCmd(CBX_LIKE_COOKIE_NAME, null); // Get cookie data  ($name, $defaultValue)
			//var_dump($cookie_value);


		}

		/**
		 * Get the ip address of the user
		 *
		 * @return string|void
		 */
		public static function get_ipaddress()
		{

			if (empty($_SERVER["HTTP_X_FORWARDED_FOR"])) {

				$ip_address = $_SERVER["REMOTE_ADDR"];
			} else {

				$ip_address = $_SERVER["HTTP_X_FORWARDED_FOR"];
			}
			if (strpos($ip_address, ',') !== false) {

				$ip_address = explode(',', $ip_address);
				$ip_address = $ip_address[0];
			}

			return $ip_address;
		}
	}