<?php
	/*------------------------------------------------------------------------
	# cblike.php - Stand Alone Like Component
	# ------------------------------------------------------------------------
	# author    Joomboxr Team
	# copyright Copyright (C) 2010-2016 joomboxr.com. All Rights Reserved
	# license   GNU/GPL Version 2 or later - http://www.gnu.org/licenses/gpl-2.0.html
	# Support Forum   http://joomboxr.com/product/cbx-like/
	-------------------------------------------------------------------------*/

// No direct access to this file
	defined('_JEXEC') or die('Restricted access');

// import Joomla modelitem library
	jimport('joomla.application.component.modelitem');

	require_once JPATH_SITE . '/components/com_cblike/helpers/cblikehelper.php';

	/**
	 * HelloWorld Model
	 */
	class CbLikeModelCbLike extends JModelItem
	{
		/**
		 * Function for getting the like counts from database
		 * @param type extension name
		 * @param type view name
		 * @param type item/article id
		 * @return type
		 */

		public function getShowcount($ext, $view, $itemid)
		{

			return json_encode($this->stat($ext, $view, $itemid));


		} //end of function getLike


		/**
		 * Update likes count using ajax
		 *
		 * @return boolean
		 */
		public function getDolike()
		{

			$app      = JFactory::getApplication();
			$language = JFactory::getLanguage();
			$language->load('plg_content_cblikebutton', JPATH_ADMINISTRATOR);


			//jimport( 'joomla.session.session' );

			$rawdata = $app->input->getVar('data');
			$data    = json_decode($rawdata);


			$data_array = explode('-', base64_decode($data->data)); // change var name

			$extype = $data_array[0];
			$view   = $data_array[1];
			$itemid = $data_array[2];
			$token  = $data->authtoken;

			// Checking the token
			$session = JFactory::getSession();
			if (!$session->hasToken($token))
				return array("error" => JText::_("PLG_CBLIKEBUTTON_COM_CBLIKE_SESSION_ERROR"));


			//$ipaddr             = $app->input->getVar('REMOTE_ADDR', '', 'SERVER');

			$datetime = date('Y-m-d H:i:s', time());

			$plugin = JPluginHelper::getPlugin('content', 'cblikebutton');
			if ($plugin) {
				// Get plugin params
				$pluginParams = new JRegistry($plugin->params);

				//cookie time and logmethod
				$cookietime = intval($pluginParams->get('cookietime', 1));  // day
				$logmethod  = intval($pluginParams->get('logmethod', 1));  //3 = //cookie or ip any math  2 = //cookie and ip both math, 1 = cookie  , 0 = ip


				if ($cookietime == 0) $cookietime = 1; //safe side

				defined('CBX_LIKE_COOKIE_SET') or CbLikeHelper::init_cookie($cookietime);

			} else {
				return array("error" => JText::_("PLG_CBLIKEBUTTON_PLG_CBLIKE_NOTFOUND"));
			}


			$user    = JFactory::getUser();
			$user_id = $user->id;

			//$userid     = $userinfo->id;

			if ($user_id == 0) {
				$user_session = $_COOKIE[CBX_LIKE_COOKIE_NAME]; //this is string
				$username     = '';
			} elseif ($user_id > 0) {
				$user_session = 'user-' . $user_id; //this is string
				$username     = $user->username;
			}

			$user_ip = CbLikeHelper::get_ipaddress();

			$isvoted = $this->isVoted($logmethod, $user_ip, $user_id, $user_session, $extype, $view, $itemid);

			if($isvoted){
				$voted_response = array(
					'msg' 		=> JText::_('PLG_CBLIKEBUTTON_ALREADYVOTED'),
					'isVoted'	=> 1
				);

				return json_encode($voted_response);
			}


			$stat = $this->stat($extype, $view, $itemid);


			if (!empty($stat)) {
				$this->inserttrack($extype, $itemid, $view, $user_id, $username, $datetime, $user_ip, $user_session);
				$update_resp = $this->updatesummary($stat, $extype, $itemid, $username, $user_id);

			} else {
				$this->inserttrack($extype, $itemid, $view, $user_id, $username, $datetime, $user_ip, $user_session);
				$sum_insert_resp = $this->insertsummary($extype, $itemid, $username, $user_id, $view);

			}

			return json_encode($this->stat($extype, $view, $itemid));

		} // end of function getDolike


		/**
		 *  This function returns true for false based on user's vote
		 *
		 * @param int $logmethod
		 * @param     $user_id
		 * @param     $user_ip
		 * @param     $user_session
		 * @param     $ext
		 * @param     $view
		 * @param     $itemid
		 *
		 * @return bool|int
		 */
		public function isVoted($logmethod = 1, $user_ip, $user_id, $user_session, $ext, $view, $itemid)
		{



			switch ($logmethod) {
				case 3:
					//cookie or ip any math


					$db    = JFactory::getDbo();
					$query = $db->getQuery(true);

					$query->select("count(id)");
					$query->from("#__cbliker_liketrack");

					if ($user_id > 0) {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid'  AND userid = '$user_id'");
					} else {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid' AND ipaddress= '$user_ip' OR usersession = '$user_session' ");
					}


					$db->setQuery($query);

					return (int)$db->loadResult();

					break;
				case 2:
					//cookie and ip both


					$db    = JFactory::getDbo();
					$query = $db->getQuery(true);

					$query->select("count(id)");
					$query->from("#__cbliker_liketrack");

					if ($user_id > 0) {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid'  AND userid = '$user_id'");
					} else {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid' AND ipaddress= '$user_ip' AND usersession = '$user_session' ");
					}


					$db->setQuery($query);

					return (int)$db->loadResult();

					break;
				case 1:
					//cookie method
					$db    = JFactory::getDbo();
					$query = $db->getQuery(true);

					$query->select("count(id)");
					$query->from("#__cbliker_liketrack");

					if ($user_id > 0) {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid'  AND userid = '$user_id' ");
					} else {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid' AND usersession = '$user_session' ");
					}


					$db->setQuery($query);

					return (int)$db->loadResult();
					break;
				case 0:
					//ip method
					$db    = JFactory::getDbo();
					$query = $db->getQuery(true);

					$query->select("count(id)");
					$query->from("#__cbliker_liketrack");

					if ($user_id > 0) {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid'  AND userid = '$user_id' ");
					} else {
						$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = '$itemid' AND ipaddress= '$user_ip'  ");
					}


					$db->setQuery($query);

					return (int)$db->loadResult();
					break;
			}


		}


		public function getStatshow()
		{
			$app = JFactory::getApplication();


			$rawdata = $app->input->getVar('data');

			$data_array = explode('-', base64_decode($rawdata)); // change var name

			$ext    = $data_array[0];
			$view   = $data_array[1];
			$itemid = $data_array[2];

			$return_data = array();

			$userinfo = JFactory::getUser();
			$user     = $userinfo->username;

			if (empty($user)) $user = '';

			$stat = $this->stat($ext, $view, $itemid);


			if ($user != 'guest' && (isset($stat ["usernames"]) && array_key_exists($user, json_decode($stat["usernames"])))) {
				$return_data['userliked'] = 1;
			} else {
				$return_data['userliked'] = 0;
			}

			$return_data['stat'] = $stat;

			return json_encode($return_data);

		} // end of function statshow


		/**
		 * Getting data from database
		 * @param string extension name
		 * @param string view name
		 * @param integer Item ID
		 * @return array
		 */
		public function stat($ext, $view, $itemid)
		{


			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);

			$query->select("id");
			$query->select("likecount");
			$query->select("guestlike");
			$query->select("usernames");
			$query->from("#__cbliker_likesummary");
			$query->where("extensionname = '$ext' AND viewname = '$view' AND itemid = $itemid");

			//$query1 = "SELECT likecount FROM #__cbliker_likesummary WHERE `extensiontype` = '$extype' AND `itemid` = $itemid";


			$db->setQuery($query);

			return $db->loadAssoc();

		} //end of private function get

		/**
		 * Inserting data in track table
		 *
		 * @param string $extype
		 * @param integer $itemid
		 * @param string $view
		 * @param string $ipaddr
		 * @param integer $userid
		 * @param string $user
		 * @param datetime $datetime
		 */

		private function inserttrack($extype, $itemid, $view, $user_id, $username = '', $datetime, $user_ip, $user_session)
		{

			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);


			$values = array(
				$db->quote($extype),
				$db->quote($itemid),
				$db->quote($view),
				$db->quote($user_id),
				$db->quote($username),
				$db->quote($datetime),
				$db->quote($user_ip),
				$db->quote($user_session)
			);

			$query->insert($db->quoteName('#__cbliker_liketrack'))
				->columns($db->quoteName(array('extensionname', 'itemid', 'viewname', 'userid', 'username', 'created', 'ipaddress', 'usersession')))
				->values(implode(',', $values));

			$db->setQuery($query);
			$db->execute();
		}

		/**
		 * Inserting data in summary table
		 *
		 * @param string Extension Name
		 * @param integer Item ID
		 * @param string User name
		 * @param integer User ID
		 * @param string Viewname
		 */

		private function insertsummary($extype, $itemid, $user, $userid, $view)
		{

			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);

			$usernames = array();

			// Setting up queries

			if (empty($user)) {

				$user      = '';
				$guestlike = 1;
				//$usernames[$user] =  $userid;
				$newusernames = json_encode($usernames);

				$values = array(
					$db->quote($extype),
					$db->quote($itemid),
					$db->quote(1),
					$db->quote($guestlike),
					$db->quote($newusernames),
					$db->quote($view)
				);


				$query->insert($db->quoteName('#__cbliker_likesummary'))
					->columns($db->quoteName(array('extensionname', 'itemid', 'likecount', 'guestlike', 'usernames', 'viewname')))
					->values(implode(',', $values));
			} else {

				$usernames[$user] = $userid;
				$newusernames     = json_encode($usernames);

				$values = array(
					$db->quote($extype),
					$db->quote($itemid),
					$db->quote(1),
					$db->quote($newusernames),
					$db->quote($view)
				);


				$query->insert($db->quoteName('#__cbliker_likesummary'))
					->columns($db->quoteName(array('extensionname', 'itemid', 'likecount', 'usernames', 'viewname')))
					->values(implode(',', $values));
			}

			// Now executing the query

			$db->setQuery($query);
			$db->execute();


		}

		/**
		 * Updating summary table
		 *
		 * @param array $stat
		 * @param string $extype
		 * @param integer $itemid
		 * @param string $user
		 * @param integer $userid
		 */
		private function updatesummary($stat, $extype, $itemid, $user, $userid)
		{


			$db    = JFactory::getDbo();
			$query = $db->getQuery(true);

			$id           = $stat['id'];
			$newlikecount = $stat['likecount'] + 1;


			$usernames = json_decode($stat['usernames'], true);


			if (empty($user)) {

				$user         = '';
				$newguestlike = $stat['guestlike'] + 1;


				$query->update($db->quoteName('#__cbliker_likesummary'));
				$query->set("`extensionname` = '$extype'");
				$query->set("`itemid` = '$itemid'");
				$query->set("`likecount` = '$newlikecount'");
				$query->set("`guestlike` = '$newguestlike'");
				// $query->set("`usernames` = '$newusernames'");
				$query->where("`id` = $id");

			} else {

				$usernames[$user] = $userid;

				$newusernames = json_encode($usernames);


				$query->update($db->quoteName('#__cbliker_likesummary'));
				$query->set("`extensionname` = '$extype'");
				$query->set("`itemid` = '$itemid'");
				$query->set("`likecount` = '$newlikecount'");
				//$query->set("`guestlike` = '$newguestlike'");
				$query->set("`usernames` = '$newusernames'");
				$query->where("`id` = $id");

			}

			$db->setQuery($query);
			$db->execute();


		}


	}